<template>
  <div
    class="wrapper slide-wrapper"
    ref="slide"
    v-waypoint="{active: isWaypointActive, callback: animateSlide, options: {threshold: [0.25, 1]}}"
  >
    <div class="container slide-container">
      <main class="slide">
        <div class="slide-top">
          <div class="slide__title">
            For centuries...
          </div>
          <div class="slide__text">
            ...heroes have searched for the lost treasures of the dragons but <span class="text-green">with no luck</span>
          </div>
          <div class="slide__text">
            A vital clue was kept hidden by Plutus as commanded <span class="text-green">by Zeus</span>
          </div>
        </div>
        <div class="slide-bottom">
          <div class="slide__text">
            Now, this clue has been revealed...
          </div>
          <div class="slide__text">
            The lost treasure resting place is within the cores of <span class="text-green">Mount ETNA</span>
          </div>
        </div>
      </main>
    </div>
  </div>
</template>

<script>
import isMobilePlatform from "@/utils";

export default {
  name: "MainPageSlide",
  data() {
    return {
      isWaypointActive: true
    }
  },
  methods: {
    animateSlide(data) {
      const isMobile = isMobilePlatform()
      if (data.going !== 'in') return
      const tl = this.$anime.timeline({
        easing: 'easeOutSine',
      })

      if (!isMobile) {
        tl
          .add({
            targets: this.$refs.slide,
            height: [0, '100vh'],
            backgroundSize: ['150%', '100%'],
            duration: 600,
          })
      }

      tl
        .add({
          targets: '.slide-top > .slide__title, .slide-top > .slide__text',
          translateX: [-200, 0],
          opacity: [0, 1],
          duration: 800,
          delay: 200,
        })
        .add({
          targets: '.slide-bottom > .slide__text',
          translateX: [200, 0],
          opacity: [0, 1],
          duration: 800,
        })

      if (!isMobile) {
        tl
          .add({
            targets: this.$refs.slide,
            backgroundSize: ['100%', '125%'],
            duration: 10000,
          }, 600)
      }


      this.isWaypointActive = false
    }
  }
}
</script>

<style scoped lang="sass">
@import "~@/assets/sass/components/MainPage/MainPageSlide.sass"
</style>
